searchNodes=[{"doc":"Elixir implementation of Binary Object Representation Serializer for Hashing ( borsh ) Usage Define schema using BorshEx.Schema defmodule SubData do use BorshEx.Schema defstruct address : nil borsh_schema do field :address , &quot;string&quot; end end defmodule Data do use BorshEx.Schema defstruct name : nil borsh_schema do field :id , &quot;u16&quot; field :sub_data , SubData end end Once schema is define, we are able to serialize a struct into a binary or deserialize to a struct. iex&gt; data = % Data { id : 45 , sub_data : % SubData { address : &quot;Hello world!&quot; } } % Data { id : 45 , sub_data : % SubData { address : &quot;Hello world!&quot; } } iex&gt; bistring = Data . serialize ( data ) &lt;&lt; 45 , 0 , 12 , 0 , 0 , 0 , 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 33 &gt;&gt; iex&gt; data = Data . deserialize ( bitstring ) { :ok , % Data { id : 45 , sub_data : % SubData { address : &quot;Hello world!&quot; } } } In some case the bitstring is longer than necessary, some bytes are not used iex&gt; bitstring = &lt;&lt; 45 , 0 , 12 , 0 , 0 , 0 , 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 33 , 5 , 0 &gt;&gt; &lt;&lt; 45 , 0 , 12 , 0 , 0 , 0 , 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 33 , 10 , 5 , 0 &gt;&gt; iex&gt; data = Data . deserialize ( bitstring ) { :error , % Data { id : 45 , sub_data : % SubData { address : &quot;Hello world!&quot; } } , &lt;&lt; 5 , 0 &gt;&gt; } &lt;&lt;5, 0&gt;&gt; returned are unused bytes. Basic types type example u8 , u16 , u32 , u64 field :id, &quot;u8&quot; i8 , i16 , i32 , i64 field :id, &quot;i8&quot; boolean field :id, &quot;bool&quot; string field :id, &quot;string&quot; struct field :id, MyStruct Complex types All types can be used in a more complex one Array An array can have a fixed size # ids is a list of 32 `u16` values # sub_data is a list of 32 Subdata strut borsh_schema do field :ids , { &quot;array&quot; , { &quot;u16&quot; , 32 } } field :sub_data , { &quot;array&quot; , { Subdata , 32 } } end Or variable length # ids is a list `u16` value # sub_data is a list of Subdata strut borsh_schema do field :ids , { &quot;array&quot; , &quot;u16&quot; } field :sub_data , { &quot;array&quot; , { Subdata , 32 } } end Option a field can be optional # if name can be nil or a string borsh_schema do field :name , { &quot;option&quot; , &quot;string&quot; } end iex&gt; data = % Data { name : nil } % Data { name : nil } iex&gt; Data . serialize ( data ) &lt;&lt; 0 &gt;&gt; iex&gt; data = % Data { name : &quot;Hello&quot; } % Data { name : &quot;Hello&quot; } iex&gt; Data . serialize ( data ) &lt;&lt; 1 , 5 , 0 , 0 , 0 , 72 , 101 , 108 , 108 , 111 &gt;&gt;","ref":"BorshEx.html","title":"BorshEx","type":"module"},{"doc":"Define a Borsh schema for a given struct Example defmodule Data do use BorshEx.Data defstruct id : nil , sub_data : nil borsh_schema do field :id , &quot;u16&quot; field :sub_data , SubData end end","ref":"BorshEx.Schema.html","title":"BorshEx.Schema","type":"behaviour"},{"doc":"Defines a schema to serialize / deserialize the struct","ref":"BorshEx.Schema.html#borsh_schema/1","title":"BorshEx.Schema.borsh_schema/1","type":"macro"},{"doc":"Deserialize bitstring into the struct Example iex&gt; FakeData . deserialize ( &lt;&lt; 255 , 20 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 3 , 0 , 0 , 0 , 49 , 50 , 51 &gt;&gt; ) iex&gt; { :ok , % FakeData { a : 255 , b : 20 , c : &quot;123&quot; } } iex&gt; FakeData . deserialize ( &lt;&lt; 255 , 20 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 3 , 0 , 0 , 0 , 49 , 50 , 51 , 87 &gt;&gt; ) iex&gt; { :error , % FakeData { a : 255 , b : 20 , c : &quot;123&quot; } , &lt;&lt; 87 &gt;&gt; }","ref":"BorshEx.Schema.html#c:deserialize/1","title":"BorshEx.Schema.deserialize/1","type":"callback"},{"doc":"Defines a field on the schema with given name and type.","ref":"BorshEx.Schema.html#field/2","title":"BorshEx.Schema.field/2","type":"macro"},{"doc":"Serialize struct into a bitstring Example iex&gt; fake_data = % FakeData { a : 255 , b : 20 , c : &quot;123&quot; } iex&gt; FakeData . serialize ( fake_data ) &lt;&lt; 255 , 20 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 3 , 0 , 0 , 0 , 49 , 50 , 51 &gt;&gt;","ref":"BorshEx.Schema.html#c:serialize/1","title":"BorshEx.Schema.serialize/1","type":"callback"},{"doc":"Copyright (c) 2022, Stéphane Robino All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"License","type":"extras"},{"doc":":warning: Work in progress Elixir implementation of Binary Object Representation Serializer for Hashing ( borsh )","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding borsh_ex to your list of dependencies in mix.exs : def deps do [ { :borsh_ex , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/borsh_ex .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"defmodule BorshEx.FakeData do use BorshEx.Schema defstruct a : nil , b : nil , c : nil borsh_schema do field :a , &quot;u8&quot; field :b , &quot;u64&quot; field :c , &quot;string&quot; end end","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Copyright (c) 2022, Stéphane Robino This library is licensed under the BSD-2-Clause.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]